
// speedtestDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "speedtest.h"
#include "speedtestDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CspeedtestDlg-Dialogfeld



CspeedtestDlg::CspeedtestDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_SPEEDTEST_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_ModeType = 0;
}

void CspeedtestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, m_DeviceList);
	DDX_Control(pDX, IDC_CMB_MODE, m_Mode);
	DDX_Control(pDX, IDC_PROGRESS1, m_Progress);
}

BEGIN_MESSAGE_MAP(CspeedtestDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON2, &CspeedtestDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON4, &CspeedtestDlg::OnBnClickedButton4)
	ON_CBN_SELCHANGE(IDC_CMB_MODE, &CspeedtestDlg::OnCbnSelchangeCmbMode)
	ON_CBN_SELCHANGE(IDC_COMBO1, &CspeedtestDlg::OnCbnSelchangeCombo1)
END_MESSAGE_MAP()


// CspeedtestDlg-Meldungshandler

BOOL CspeedtestDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen.  Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	m_bRun = false;
	m_ModeType = JW56FR1_ENDPOINT_ACC_SPEED;
	m_Mode.SetCurSel(0);
	m_Progress.SetRange(0, 10);
	m_Progress.SetStep(1);
	m_ProgCount = 0;


	return TRUE;  // TRUE zurckgeben, wenn der Fokus nicht auf ein Steuerelement gesetzt wird
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
//  den nachstehenden Code, um das Symbol zu zeichnen.  Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void CspeedtestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CspeedtestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CALLBACK CspeedtestDlg::MM_TimerFunction(UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	CspeedtestDlg* obj = (CspeedtestDlg*)dwUser;
	obj->MM_TimerHandler(wTimerID);
}

UINT CspeedtestDlg::MM_SetTimer(UINT ms)
{
	UINT eventID = 0;
	TIMECAPS tc;

	timeGetDevCaps(&tc, sizeof(TIMECAPS));

	DWORD resolution = min(max(tc.wPeriodMin, 0), tc.wPeriodMax);
	timeBeginPeriod(resolution);

	eventID = timeSetEvent(ms, resolution, MM_TimerFunction, (DWORD)this, TIME_PERIODIC);
	return eventID;
}

void CspeedtestDlg::MM_KillTimer(UINT nIDEvent)
{
	timeKillEvent(nIDEvent);
}

void CspeedtestDlg::MM_TimerHandler(UINT nIDEvent)
{
	CString csv;
	BYTE buffer[JW56FR1_SPEED_SIZE_SPEED] = { 0 };
	CString values;


	//HIDP_CAPS caps = jw_GetHipdCaps(m_Device.read[JW56FR1_ENDPOINT_ROT_SPEED]);
	int numRead = jw_GetData(m_Device.read[m_ModeType], m_Caps, buffer);


	if (numRead > 0)
	{
		csv.Format(L"%d %d %d\r\n", (buffer[1] | (buffer[2] << 8)), (buffer[3] | (buffer[4] << 8)), (buffer[5] | (buffer[6] << 8)));
		m_File.Write((LPCTSTR)csv, csv.GetLength() * sizeof(TCHAR));

		csv.Format(L"%d %d %d\r\n", (buffer[7] | (buffer[8] << 8)), (buffer[9] | (buffer[10] << 8)), (buffer[11] | (buffer[12] << 8)));
		m_File.Write((LPCTSTR)csv, csv.GetLength() * sizeof(TCHAR));

		csv.Format(L"%d %d %d\r\n", (buffer[13] | (buffer[14] << 8)), (buffer[15] | (buffer[16] << 8)), (buffer[17] | (buffer[18] << 8)));
		m_File.Write((LPCTSTR)csv, csv.GetLength() * sizeof(TCHAR));

		csv.Format(L"%d %d %d\r\n", (buffer[19] | (buffer[20] << 8)), (buffer[21] | (buffer[22] << 8)), (buffer[23] | (buffer[24] << 8)));
		m_File.Write((LPCTSTR)csv, csv.GetLength() * sizeof(TCHAR));

		csv.Format(L"%d %d %d\r\n", (buffer[25] | (buffer[26] << 8)), (buffer[27] | (buffer[28] << 8)), (buffer[29] | (buffer[30] << 8)));
		m_File.Write((LPCTSTR)csv, csv.GetLength() * sizeof(TCHAR));
	}

	m_ProgCount++;

	if (m_ProgCount >= 100)
	{
		m_Progress.StepIt();
		m_ProgCount = 0;
	}
}


void CspeedtestDlg::OnCbnSelchangeCombo1()
{
	jw_GetDeviceHandles(CODEMERCS_VID, JW56FR1_PID, m_SerialList[m_DeviceList.GetCurSel()], &m_Device);
	m_Caps = jw_GetHipdCaps(m_Device.read[JW56FR1_ENDPOINT_ROT_SPEED]);
	jw56fr1_SetParams(m_Device.write[JW56FR1_ENDPOINT_DEFAULT], 0, 0, 1, 0);

	GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
}

void CspeedtestDlg::OnBnClickedButton2()
{
	//Datei anlegen
	CString csv = _T("X Y Z temp \r\n");
	CFileDialog cDialog(FALSE, 0, 0, 4 | 2, _T("CSV (*.csv) |*.csv||"), 0, 0);

	if (m_IsFile == false)
	{
		if (cDialog.DoModal() == IDOK)
		{
			if (cDialog.GetFileExt() == _T(""))
				m_Path.Format(_T("%s.csv"), cDialog.GetPathName());
			else
				m_Path.Format(_T("%s"), cDialog.GetPathName());

			m_File.Open(m_Path, CFile::modeCreate | CFile::modeWrite);

			//Schreibe in Datei
			m_File.Write((LPCTSTR)csv, csv.GetLength() * sizeof(TCHAR));

			//m_File.Close();
			m_IsFile = true;
		}
	}

	if (m_IsFile == true)
	{
		
		if (m_bRun == false)
		{
			//jw56fr1_SetParams(m_Device.write[0], JW56FR1_ARNG_RANGE_2G, JW56FR1_AFILT_NONE, JW56FR1_GRNG_125DPS, JW56FR1_GFILT_NONE);

			GetDlgItem(IDC_BUTTON2)->SetWindowTextW(L"Stop");
			m_Mode.EnableWindow(FALSE);
			GetDlgItem(IDC_COMBO1)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON4)->EnableWindow(FALSE);
			m_bRun = true;
			jw56fr1_SetMode(m_Device.write[JW56FR1_ENDPOINT_DEFAULT], 0x01);
			m_nIDEvent = MM_SetTimer(2);	//Multimediatimer in ms
		}
		else
		{
			//jw_CloseHandle(m_Device.write);
			//jw_CloseHandle(m_Device.read);

			MM_KillTimer(m_nIDEvent);
			jw56fr1_SetMode(m_Device.write[JW56FR1_ENDPOINT_DEFAULT], 0x00);
			GetDlgItem(IDC_BUTTON2)->SetWindowTextW(L"Run");
			GetDlgItem(IDC_COMBO1)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON4)->EnableWindow(TRUE);
			m_Mode.EnableWindow(TRUE);
			m_bRun = false;
			m_IsFile = false;
			m_File.Close();
		}
	}
}


void CspeedtestDlg::OnBnClickedButton4()
{
	int num = jw_GetDeviceList(CODEMERCS_VID, JW56FR1_PID, m_SerialList);

	m_DeviceList.ResetContent();

	for (int i = 0; i < num; i++)
		m_DeviceList.AddString(m_SerialList[i]);

	if (num == 0)
	{
		MessageBoxW(L"NO JW56FR1 found on USB", L"DEVICE ERROR", MB_OK | MB_ICONERROR);
		GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
	}

	if (num == 1)
	{
		m_DeviceList.SetCurSel(0);
		OnCbnSelchangeCombo1();
	}
}


void CspeedtestDlg::OnCbnSelchangeCmbMode()
{
	if (m_Mode.GetCurSel() == 0)
		m_ModeType = JW56FR1_ENDPOINT_ACC_SPEED;
	else
		m_ModeType = JW56FR1_ENDPOINT_ROT_SPEED;
}



